"use strict";
/// <reference types="@fibjs/types" />
Object.defineProperty(exports, "__esModule", { value: true });
exports.loader = exports.generateLoaderbox = exports.loaderBox = exports.compileDirectoryTo = exports.compileFileToSandBox = exports.compileFileTo = exports.compileFile = exports.compileRawToSandBox = exports.compileRawToFile = exports.compileRaw = exports.compileModule = exports.defaultCompilerOptions = exports.registerTsCompiler = exports.builtModules = exports.createProgram = exports.createCompilerHost = exports.ChainLoader = void 0;
const vm = require("vm");
const compileModule = require('../core/transpile/module').compileModule;
exports.compileModule = compileModule;
const { compileRaw, compileRawToFile, compileRawToSandBox, } = require('../core/transpile/raw');
exports.compileRaw = compileRaw;
exports.compileRawToFile = compileRawToFile;
exports.compileRawToSandBox = compileRawToSandBox;
const { compileFile, compileFileTo, compileFileToSandBox, } = require('../core/transpile/fs-file');
exports.compileFile = compileFile;
exports.compileFileTo = compileFileTo;
exports.compileFileToSandBox = compileFileToSandBox;
const { compileDirectoryTo } = require('../core/transpile/fs-directory');
exports.compileDirectoryTo = compileDirectoryTo;
/**
 * @deprecated
 */
const loaderBox = require('../core/loader-box').defaultBox;
exports.loaderBox = loaderBox;
/**
 * @deprecated
 */
const generateLoaderbox = require('../core/loader-box').generateLoaderbox;
exports.generateLoaderbox = generateLoaderbox;
const builtModules = require('../core/_utils').builtModules;
exports.builtModules = builtModules;
const registerTsCompiler = require('../core/_utils').registerTsCompiler;
exports.registerTsCompiler = registerTsCompiler;
const defaultCompilerOptions = require('../core/_utils').defaultCompilerOptions;
exports.defaultCompilerOptions = defaultCompilerOptions;
const defaultSandboxFallback = name => require(name);
class ChainLoader {
    constructor(moduleOptions = {}, sandboxOptions) {
        this.setModuleOptions(moduleOptions);
        sandboxOptions && typeof sandboxOptions === 'object' && this.sandbox(sandboxOptions['modules'], sandboxOptions['fallback'], sandboxOptions['global']);
    }
    setModuleOptions(_moduleOptions) {
        this._moduleOptions = _moduleOptions || {};
    }
    sandbox(...args) {
        var _a;
        if (this._sandbox)
            return this._sandbox;
        if (args[0] instanceof vm.SandBox)
            this._sandbox = args.shift();
        else {
            const modules = Object.assign(Object.assign({}, builtModules), args.shift());
            let fallback = args.shift() || defaultSandboxFallback;
            let _global = args.shift() || undefined;
            this._sandbox = new vm.SandBox(modules, fallback, _global);
        }
        const loader = this;
        Object.defineProperty(this._sandbox, 'loader', {
            value: function () {
                return loader;
            }
        });
        const set_loader = args[3] || args[1];
        if (typeof set_loader === 'function')
            set_loader(this);
        registerTsCompiler(this._sandbox, (_a = this._moduleOptions) === null || _a === void 0 ? void 0 : _a.compilerOptions);
        return this.sandbox();
    }
}
exports.ChainLoader = ChainLoader;
const programApis = require('../core/ts-apis/program');
exports.createCompilerHost = programApis.createCompilerHost;
exports.createProgram = programApis.createProgram;
/**
 * @deprecated
 */
function loader(...args) {
    const loader = new ChainLoader(args[0], args[1]);
    return loader;
}
exports.loader = loader;
